## Script (Python) "remove_students"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=REQUEST
##title=
##
# $Id: remove_students.py 2396 2007-10-19 14:17:29Z joachim $
"""
remove a list of students
"""
try:
    from Products.zdb import set_trace
except:
    def set_trace():
        pass

import logging
logger = logging.getLogger('Skins.remove_students')
from Products.AdvancedQuery import Eq, Between, Le,In
#aq_portal = context.portal_catalog_real.evalAdvancedQuery
aq_students = context.students_catalog.evalAdvancedQuery
students_folder = context.portal_url.getPortalObject().campus.students
stdir = context.portal_directories.students
mtool = context.portal_membership
member = mtool.getAuthenticatedMember()
rget = REQUEST.form.get
info = {}
info['member'] = member
info['is_so'] = context.isSectionOfficer()
ids = info['choosen_ids'] = rget('ids',[])
search_list = rget('search_string','')
delete = rget('delete',None)
info['search_string'] = search_list
student_ids = search_list.split()
students = []
#set_trace()
psm = 'nothing done'
deleted_list = []
if delete:
    if not ids:
        psm = "nothing checked"
    else:
        for student_id in ids:
            logger.info("%s deletes student %s" % (member,student_id))
            if hasattr(students_folder,student_id):
                students_folder.manage_delObjects((student_id),)
                logger.info("%s deleted student object for %s" % (member,student_id))
            else:
                logger.info("No student object for %s" % (student_id))
                continue
            # remove from directory
            if hasattr(stdir, student_id):
                stdir.deleteEntry(student_id)
                logger.info("%s deleted Student directory for %s" % (member,student_id))
            else:
                logger.info("No Student directory for %s" % (student_id))
                continue
            context.waeup_tool.removePictureFolder(student_id)
            deleted_list.append(student_id)
            
        psm = "%s deleted" % ' '.join(deleted_list)
if student_ids:
    brains = aq_students(In('id',student_ids))
    brains_dict = {}
    if brains:
        for b in brains:
            brains_dict[b.id] = b
    for student_id in student_ids:
        student = {}
        student['deleted'] = delete and student_id in ids
        if student_id in brains_dict.keys():
            student['found'] = True
            student['id'] = brains_dict[student_id].id
            student['jamb_reg_no'] = brains_dict[student_id].jamb_reg_no
            student['name'] = brains_dict[student_id].name
            student['matric_no'] = brains_dict[student_id].matric_no
        else:
            student['found'] = False
            student['id'] = student_id
            student['jamb_reg_no'] = ""
            student['name'] = "not found"
            student['matric_no'] = ''
        student['show_checkbox'] = not student['deleted'] and student['found']
        students.append(student)


return context.remove_students_form(info = info,
                                    students = students,
                                    allowed = True,
                                    psm = psm,
                                    )
